=== added file 'src/com/goldencode/p2j/testengine/SerializationSupport.java'
--- src/com/goldencode/p2j/testengine/SerializationSupport.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/SerializationSupport.java	2022-10-12 21:24:04 +0000
@@ -0,0 +1,163 @@
+/*
+** Module   : SerializationSupport.java
+** Abstract : Test descriptor serialization support
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import java.io.*;
+import java.lang.reflect.*;
+import java.util.*;
+
+/**
+ * Serialization support utilities
+ *
+ */
+public class SerializationSupport
+{
+   /**
+    * Read {@link Method} from binary input stream previously serialized with
+    * {@link #writeMethod(Method, ObjectOutput)}.
+    * 
+    * @param in
+    *        the input stream to read method from
+    *        
+    * @return the method
+    * 
+    * @throws IOException
+    * @throws SecurityException
+    */
+   public final static Method readMethod(final ObjectInput in) throws IOException
+   {
+      try
+      {
+         final Class<?> clazz = (Class<?>) in.readObject();
+         final String methodName = (String) in.readObject();
+         return clazz.getMethod(methodName);
+      }
+      catch (ClassNotFoundException | NoSuchMethodException | SecurityException e)
+      {
+         throw new RuntimeException(e);
+      }
+   }
+
+   /**
+    * Read list of {@link Method} objects from binary input stream previously serialized with 
+    *  {@link #writeMethods(List, ObjectOutput)}.
+    * 
+    * @param in
+    *        the input stream to read method from
+    *        
+    * @return the method list
+    * 
+    * @throws IOException
+    * @throws SecurityException
+    */
+   public final static List<Method> readMethods(final ObjectInput in) throws IOException
+   {
+      final List<Method> result = new ArrayList<>();
+      final int size = in.readInt();
+      for (int i = 0; i < size; i++)
+      {
+         result.add(readMethod(in));
+      }
+      
+      return result;
+   }
+
+   /**
+    * Write {@link Method} to binary output stream.
+    * 
+    * @param method
+    *        the method to write
+    * @param out
+    *        the output stream to write methods to
+    *        
+    * @throws IOException
+    * @throws SecurityException
+    */
+   public final static void writeMethod(final Method method, final ObjectOutput out)
+            throws IOException, SecurityException
+   {
+      out.writeObject(method.getDeclaringClass());
+      out.writeObject(method.getName());
+   }
+
+   /**
+    * Write list of {@link Method} objects to binary output stream.
+    * 
+    * @param methods
+    *        the method list to write
+    * @param out
+    *        the output stream to write methods to
+    *        
+    * @throws IOException
+    * @throws SecurityException
+    */
+   public final static void writeMethods(final List<Method> methods, final ObjectOutput out)
+            throws IOException, SecurityException
+   {
+      out.writeInt(methods.size());
+      for (final Method m : methods)
+      {
+         writeMethod(m, out);
+      }
+   }
+
+}

=== added file 'src/com/goldencode/p2j/testengine/TestExecutionSupport.java'
--- src/com/goldencode/p2j/testengine/TestExecutionSupport.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/TestExecutionSupport.java	2022-10-21 15:40:15 +0000
@@ -0,0 +1,193 @@
+/*
+** Module   : TestExecutionSupport.java
+** Abstract : Static methods to support legacy class methods and legacy procedure execution.
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import java.lang.reflect.*;
+
+import org.junit.platform.commons.support.*;
+
+import com.goldencode.p2j.net.*;
+import com.goldencode.p2j.util.*;
+
+/**
+ * Static methods to support legacy class methods and legacy procedure execution.
+ */
+public class TestExecutionSupport
+{
+   /**
+    * Call a legacy internal procedure.
+    *
+    * @param method
+    *        the Java method converted from the legacy internal procedure
+    * @param h
+    *        the persistent procedure handle
+    */
+   final static void callProcedureMethod(final Method method, final handle h)
+   {
+      final LegacySignature annotation = method.getAnnotation(LegacySignature.class);
+      final String name = annotation.name();
+      final InvokeConfig invokeConfig = new InvokeConfig().setTarget(name);
+      invokeConfig.clone().setInHandle(h).run();
+   }
+
+   /**
+    * Call a legacy class method.
+    *
+    * @param method
+    *        the Java method converted from the legacy class method
+    * @param o
+    *        the legacy class instance or {@code null} for a static method
+    */
+   final static void callClassMethod(final Method method, final object<?> o)
+   {
+      startup:
+      {
+         TransactionManager.blockSetup();
+
+         do
+         {
+            try
+            {
+               ReflectionSupport.invokeMethod(method, o.ref());
+            }
+            catch (StopConditionException sce)
+            {
+               TransactionManager.disableLoopProtection(null);
+               TransactionManager.triggerRetry(null);
+            }
+            catch (ConditionException ce)
+            {
+               if (ce instanceof QuitConditionException)
+               {
+                  TransactionManager.setProcessingQuit(true);
+               }
+               break startup;
+            }
+            catch (RetryUnwindException ru)
+            {
+               TransactionManager.honorRetry(ru);
+            }
+            catch (Throwable th)
+            {
+               Throwable chained = th;
+
+               boolean isError = false;
+               @SuppressWarnings("unused")
+               boolean isStop = false;
+
+               // look through all causes to determine if there was an
+               // underlying error
+               while (chained != null)
+               {
+                  if (chained instanceof Error)
+                  {
+                     isError = true;
+                  }
+
+                  if (chained instanceof StopConditionException)
+                  {
+                     isStop = true;
+                  }
+
+                  if (chained instanceof SilentUnwindException)
+                  {
+                     isStop = true;
+                  }
+
+                  if (chained instanceof UnstoppableExitException)
+                  {
+                     throw new UnstoppableExitException(chained);
+                  }
+
+                  chained = chained.getCause();
+               }
+
+               // treat Exception (but not Error) types the same as if
+               // we got a STOP
+               if (!isError)
+               {
+
+                  TransactionManager.disableLoopProtection(null);
+                  TransactionManager.triggerRetry(null);
+               }
+               else
+               {
+                  // the abend was an instance of Error - this is so
+                  // severe that we can't let the user continue 
+
+                  // set the flag to allow direct exit since we have such
+                  // a severe problem that we are going to exit to the
+                  // client BUT we MUST do this without trying to access
+                  // the client any further (via LogicalTerminal's
+                  // pauseBeforeEnd())
+                  TransactionManager.setProcessingQuit(true);
+
+                  // re-throw to ensure that we exit
+                  throw new RuntimeException(th);
+               }
+            }
+
+         }
+         while (TransactionManager.needsRetry());
+      }
+   }
+}

=== added file 'src/com/goldencode/p2j/testengine/UnitTestEngine.java'
--- src/com/goldencode/p2j/testengine/UnitTestEngine.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/testengine/UnitTestEngine.java	2022-10-12 21:25:46 +0000
@@ -0,0 +1,152 @@
+/*
+** Module   : UnitTestEngine.java
+** Abstract : FWD unit test remote protocol
+**
+** Copyright (c) 2022, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ----------------Description----------------------
+** 001 VVT 2022xxxx Created initial version.
+*/
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+package com.goldencode.p2j.testengine;
+
+import org.junit.platform.engine.*;
+import org.junit.platform.engine.support.hierarchical.*;
+
+/**
+ * Interface to support FWD unit testing engine remote operations. See {@link UnitTestServer}
+ * for the implementation.
+ */
+public interface UnitTestEngine
+{
+   /**
+    * Execute the <em>after</em> behavior of this node.
+    *
+    * <p>This method will be called once <em>after</em> {@linkplain #execute
+    * execution} of this node.
+    * 
+    * @param testId
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    * 
+    */
+   public void after(final UniqueId testId) throws Exception;
+
+   /**
+    * Execute the <em>before</em> behavior of this node.
+    *
+    * <p>This method will be called once <em>before</em> {@linkplain #execute
+    * execution} of this node.
+    * 
+    * @param testId 
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    */
+   public void before(final UniqueId testId) throws Exception;
+
+   /**
+    * Clean up the supplied {@code context} after execution.
+    * 
+    * Reset the test class instance.
+    * @param testId 
+    *        test descriptor ID
+    *
+    * @throws Exception 
+    *
+    * @see #prepare
+    */
+   public void cleanUp(final UniqueId testId) throws Exception;
+
+   /**
+    * @param uniqueId 
+    * @param packageSelectors 
+    * @param classSelectors 
+    * @param methodSelectors 
+    * 
+    * @return the test descriptor discovered or {@code null} if no match was found.
+    *  
+    */
+   public TestDescriptor discover(final UniqueId uniqueId, final String[] packageSelectors,
+            final String[] classSelectors, final String[] methodSelectors);
+
+   /**
+    * Execute the <em>behavior</em> of this node.
+    *
+    * <p>Containers typically do not implement this method since the
+    * {@link HierarchicalTestEngine} handles execution of their children.
+    * 
+    * @param testId
+    *        test descriptor ID
+    * 
+    * @throws Exception 
+    *
+    */
+   public void execute(final UniqueId testId) throws Exception;
+
+   /**
+    * Do server-side initialization
+    */
+   public void initialize();
+
+   /**
+    * Prepare test
+    * 
+    * @param testId 
+    *        test descriptor ID
+    */
+   public void prepare(final UniqueId testId);
+
+}

